/* Autor: Sergio Blanco Cuaresma
 * Data: Agost 2002
 * Descripci: TAG Cua amb memria dinmica
 */

public class Cua {
  private NodeCua prim;
  private NodeCua ult;

  Cua(){
    prim=null;
    ult=null;
  }

  public void encuar (Object o){
    NodeCua tmp;
    
    if (this.buida()) {
      prim = new NodeCua(o, null);
      ult = prim;
    } else {
      tmp = new NodeCua(o, null);
      ult.seguent (tmp);
      ult = tmp;
    }
      
  }

  public void desencuar () throws CuaBuida {
    if (this.buida()){
      throw new CuaBuida();
    } else {
      if (ult != prim){
        prim = prim.seguent();
      } else {          // Noms hi ha 1 element
        ult = null;
        prim = null;
      }
    }
  }

  public Object cap() throws CuaBuida {
    if (this.buida()){
      throw new CuaBuida();
    } else {
      return prim.info();
    }
  }

  public boolean buida(){
    return (prim==null);
  }

  // Metode noms vlid per cues que contenen Treballs!!!
  //  Mostra informaci per pantalla del contingut de la cua
  public void imprimir(){
    NodeCua tmp;
    tmp=prim;
    while (tmp!=null){
      ((Treball)(tmp.info())).imprimir();
      tmp=tmp.seguent();
    }
  }
      
}





