/*
 * Joc de proves de la practica 1
 * Cal assegurar-se de que la practica passa aquest joc de proves
 * abans d'entregar-la.
 */
public class prova1 {

    public static void mostra(Gestor g) {
        g.imprimir();
    }

    public static void mostra(Treball t) {
        t.imprimir();
    }
    
    public static void main (String args[]) throws NoMemoria, PDIdreta, NoImpressora, NoMoreUsers, TooBig, NoTreball, NoUser, NoTreballUser, CuaBuida {
        
        Gestor ges; 
        Treball t;
        Llista l;
    
	/*
	 * Prova: Gestor amb 5 usuaris, 4 impressores i 100000 bytes de 
	 * memoria.
	 */
        ges = new Gestor(5,4,10000);
    
	// Presentem el gestor buit
        mostra(ges);
       
	//Introduim usuaris ...
        ges.afegir_usuari("Albert Fernandez");
        ges.afegir_usuari("Aida Valls");
        ges.afegir_usuari("Toni Moreno");
        ges.afegir_usuari("Robert Rallo");
        ges.afegir_usuari("Eloy Fores");
        
        //Ara ha de donar error ...
        //ges.afegir_usuari("usuari6");
        
        mostra(ges);
        
        //Ara afegim uns quants treballs a les cues
        t = new Treball("Aida Valls",3,"AV1",3000);
        ges.afegir_treball(2,t);
        t = new Treball("Robert Rallo",1,"RR1",9000);
        ges.afegir_treball(3,t);
        t = new Treball("Toni Moreno",7,"TM1",5000);
        ges.afegir_treball(2,t);
        t = new Treball("Toni Moreno",1,"TM2",1000);
        ges.afegir_treball(1,t);
        t = new Treball("Aida Valls",9,"AV2",4000);
        ges.afegir_treball(1,t);
        t = new Treball("Eloy Fores",3,"EF1",500);
        ges.afegir_treball(3,t);
        t = new Treball("Aida Valls",6,"AV3",100);
        ges.afegir_treball(3,t);
        t = new Treball("Eloy Fores",2,"EF2",100);
        ges.afegir_treball(3,t);
        mostra(ges);

        
        /* Ara el gestor hauria de quedar com:
         * IMPR1: TM2 AV2
         * IMPR2: AV1 TM1
         * IMPR3: RR1 EF1 AV3 EF2
         */
     
        //ges.afegir_treball(7,t);  //Error: Impressora inexistent
        
        t = new Treball("Aida Valls",5,"AV4",30000);
        //ges.afegir_treball(2,t);  //Error: Treball massa gran per a la impressora
        
        //Fem algunes consultes
        t = ges.primer_treball(1);  // TM1
        mostra(t);
        t = ges.primer_treball(2);  // AV1
        mostra(t);
        t = ges.primer_treball(3);  // RR1
        mostra(t);
        //t = ges.primer_treball(0);  // La cua de la 4 est buida
        
        l = ges.llistar_treballs_usuari("Aida Valls");
        l.imprimir();
        l = ges.llistar_treballs_usuari("Robert Rallo");
        l.imprimir();
        l = ges.llistar_treballs_usuari("Eloy Fores");
        l.imprimir();
        l = ges.llistar_treballs_usuari("Toni Moreno");
        l.imprimir();
        l = ges.llistar_treballs_usuari("Albert Fernandez");  // Llista buida
        l.imprimir();
        //l = ges.llistar_treballs_usuari("Joan Lopez");  //Error: Usuari inexistent
        
        System.out.println(ges.num_treballs_pendents_usuari("Aida Valls"));   //3
        System.out.println(ges.num_treballs_pendents_usuari("Robert Rallo")); //1
        System.out.println(ges.num_treballs_pendents_usuari("Eloy Fores"));   //2
        System.out.println(ges.num_treballs_pendents_usuari("Toni Moreno"));  //2
        System.out.println(ges.num_treballs_pendents_usuari("Albert Fernandez")); //0
        
        //Activem les impressores
        ges.imprimir(1);
        ges.imprimir(2);
        ges.imprimir(3);
        
        t = ges.primer_treball(1);  // AV2
        mostra(t);
        t = ges.primer_treball(2);  // AV1 (falten dues copies)
        mostra(t);
        t = ges.primer_treball(3);  // EF1
        mostra(t);
        //t = ges.primer_treball(4);  // Cap treball pendent ...
        
        mostra(ges);
        
        ges.imprimir(2);
        ges.imprimir(2);
        t = ges.primer_treball(2);   //Hauria de ser TM1
        mostra(t);
    }
}
